// News.h: interface for the CNews class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NEWS_H__864A7525_AB77_43F6_BFF5_263DB8BAA960__INCLUDED_)
#define AFX_NEWS_H__864A7525_AB77_43F6_BFF5_263DB8BAA960__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

using namespace std;

typedef vector<string> StringVector;

enum OutputType {OT_LABEL, OT_FILE, OT_EVARS};

class CNews  
{
public:
	void ParseCommand(const char *szBang);
	void SetLabelText(const char* szLabelName, const char* szPattern);
	void SetInputString(const char *str);
	void SetOutputString(const char *str);
	bool GenerateText(StringVector *v, string sPattern, string *out, bool bIgnoreNewLine);

	StringVector m_params;
	string m_sNewFileLine;
	string m_sNewLine;
	string m_sTextForFile;
	string m_sOutputFile;
	bool m_bActive;
	bool m_bUpdated;
	bool m_bAbort;

	OutputType m_Mode;

	string m_sText;
	string m_sOutputLabel;
	string m_sOnFailure;
	string m_sOnChecked;
	string m_sOnUpdated;
	string m_sName;
	string m_sURL;
	string m_sInputString;
	string m_sOutputString;
	string m_sLocalFile;
	UINT_PTR m_uTimerID;
	UINT_PTR m_nIDEvent;
	int m_UpdateInterval;
	unsigned m_UpdateThread;

	void Toggle();
	void Update();
	void Disable();
	void Enable();
	bool ReadSettings();
	bool ReadFromFile(const char *szFile, bool bFailIfNotExist);
	bool ReadParameters(char *szString, int len, StringVector *v, char *errmsg);
	CNews(string sName);
	virtual ~CNews();
};

#define NAMED_OPTION(name,option) (name + option).c_str()


#endif // !defined(AFX_NEWS_H__864A7525_AB77_43F6_BFF5_263DB8BAA960__INCLUDED_)
